package com.hai.dao;

import com.hai.entity.HighCouponAgentCode;
import com.hai.entity.HighCouponAgentCodeExample.Criteria;
import com.hai.entity.HighCouponAgentCodeExample.Criterion;
import com.hai.entity.HighCouponAgentCodeExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighCouponAgentCodeSqlProvider {

    public String countByExample(HighCouponAgentCodeExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_coupon_agent_code");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighCouponAgentCodeExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_coupon_agent_code");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighCouponAgentCode record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_coupon_agent_code");
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getCouponAgentId() != null) {
            sql.VALUES("coupon_agent_id", "#{couponAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponId() != null) {
            sql.VALUES("coupon_id", "#{couponId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.VALUES("agent_id", "#{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponAgentRecordId() != null) {
            sql.VALUES("coupon_agent_record_id", "#{couponAgentRecordId,jdbcType=BIGINT}");
        }
        
        if (record.getConvertUserPhone() != null) {
            sql.VALUES("convert_user_phone", "#{convertUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getConvertCode() != null) {
            sql.VALUES("convert_code", "#{convertCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponCodeId() != null) {
            sql.VALUES("coupon_code_id", "#{couponCodeId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponCode() != null) {
            sql.VALUES("coupon_code", "#{couponCode,jdbcType=VARCHAR}");
        }
        
        if (record.getQrCode() != null) {
            sql.VALUES("qr_code", "#{qrCode,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getAssignCouponAgentId() != null) {
            sql.VALUES("assign_coupon_agent_id", "#{assignCouponAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getAssignAgentId() != null) {
            sql.VALUES("assign_agent_id", "#{assignAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getAssignAgentName() != null) {
            sql.VALUES("assign_agent_name", "#{assignAgentName,jdbcType=VARCHAR}");
        }
        
        if (record.getRemark() != null) {
            sql.VALUES("remark", "#{remark,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getSalesTime() != null) {
            sql.VALUES("sales_time", "#{salesTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.VALUES("operator_id", "#{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.VALUES("operator_name", "#{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighCouponAgentCodeExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("`type`");
        sql.SELECT("coupon_agent_id");
        sql.SELECT("coupon_id");
        sql.SELECT("agent_id");
        sql.SELECT("coupon_agent_record_id");
        sql.SELECT("convert_user_phone");
        sql.SELECT("convert_code");
        sql.SELECT("coupon_code_id");
        sql.SELECT("coupon_code");
        sql.SELECT("qr_code");
        sql.SELECT("`status`");
        sql.SELECT("assign_coupon_agent_id");
        sql.SELECT("assign_agent_id");
        sql.SELECT("assign_agent_name");
        sql.SELECT("remark");
        sql.SELECT("create_time");
        sql.SELECT("sales_time");
        sql.SELECT("operator_id");
        sql.SELECT("operator_name");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_coupon_agent_code");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighCouponAgentCode record = (HighCouponAgentCode) parameter.get("record");
        HighCouponAgentCodeExample example = (HighCouponAgentCodeExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_coupon_agent_code");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getCouponAgentId() != null) {
            sql.SET("coupon_agent_id = #{record.couponAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponId() != null) {
            sql.SET("coupon_id = #{record.couponId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponAgentRecordId() != null) {
            sql.SET("coupon_agent_record_id = #{record.couponAgentRecordId,jdbcType=BIGINT}");
        }
        
        if (record.getConvertUserPhone() != null) {
            sql.SET("convert_user_phone = #{record.convertUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getConvertCode() != null) {
            sql.SET("convert_code = #{record.convertCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponCodeId() != null) {
            sql.SET("coupon_code_id = #{record.couponCodeId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponCode() != null) {
            sql.SET("coupon_code = #{record.couponCode,jdbcType=VARCHAR}");
        }
        
        if (record.getQrCode() != null) {
            sql.SET("qr_code = #{record.qrCode,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getAssignCouponAgentId() != null) {
            sql.SET("assign_coupon_agent_id = #{record.assignCouponAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getAssignAgentId() != null) {
            sql.SET("assign_agent_id = #{record.assignAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getAssignAgentName() != null) {
            sql.SET("assign_agent_name = #{record.assignAgentName,jdbcType=VARCHAR}");
        }
        
        if (record.getRemark() != null) {
            sql.SET("remark = #{record.remark,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getSalesTime() != null) {
            sql.SET("sales_time = #{record.salesTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_coupon_agent_code");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("coupon_agent_id = #{record.couponAgentId,jdbcType=BIGINT}");
        sql.SET("coupon_id = #{record.couponId,jdbcType=BIGINT}");
        sql.SET("agent_id = #{record.agentId,jdbcType=BIGINT}");
        sql.SET("coupon_agent_record_id = #{record.couponAgentRecordId,jdbcType=BIGINT}");
        sql.SET("convert_user_phone = #{record.convertUserPhone,jdbcType=VARCHAR}");
        sql.SET("convert_code = #{record.convertCode,jdbcType=VARCHAR}");
        sql.SET("coupon_code_id = #{record.couponCodeId,jdbcType=BIGINT}");
        sql.SET("coupon_code = #{record.couponCode,jdbcType=VARCHAR}");
        sql.SET("qr_code = #{record.qrCode,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("assign_coupon_agent_id = #{record.assignCouponAgentId,jdbcType=BIGINT}");
        sql.SET("assign_agent_id = #{record.assignAgentId,jdbcType=BIGINT}");
        sql.SET("assign_agent_name = #{record.assignAgentName,jdbcType=VARCHAR}");
        sql.SET("remark = #{record.remark,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("sales_time = #{record.salesTime,jdbcType=TIMESTAMP}");
        sql.SET("operator_id = #{record.operatorId,jdbcType=BIGINT}");
        sql.SET("operator_name = #{record.operatorName,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighCouponAgentCodeExample example = (HighCouponAgentCodeExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighCouponAgentCode record) {
        SQL sql = new SQL();
        sql.UPDATE("high_coupon_agent_code");
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getCouponAgentId() != null) {
            sql.SET("coupon_agent_id = #{couponAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponId() != null) {
            sql.SET("coupon_id = #{couponId,jdbcType=BIGINT}");
        }
        
        if (record.getAgentId() != null) {
            sql.SET("agent_id = #{agentId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponAgentRecordId() != null) {
            sql.SET("coupon_agent_record_id = #{couponAgentRecordId,jdbcType=BIGINT}");
        }
        
        if (record.getConvertUserPhone() != null) {
            sql.SET("convert_user_phone = #{convertUserPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getConvertCode() != null) {
            sql.SET("convert_code = #{convertCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponCodeId() != null) {
            sql.SET("coupon_code_id = #{couponCodeId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponCode() != null) {
            sql.SET("coupon_code = #{couponCode,jdbcType=VARCHAR}");
        }
        
        if (record.getQrCode() != null) {
            sql.SET("qr_code = #{qrCode,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getAssignCouponAgentId() != null) {
            sql.SET("assign_coupon_agent_id = #{assignCouponAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getAssignAgentId() != null) {
            sql.SET("assign_agent_id = #{assignAgentId,jdbcType=BIGINT}");
        }
        
        if (record.getAssignAgentName() != null) {
            sql.SET("assign_agent_name = #{assignAgentName,jdbcType=VARCHAR}");
        }
        
        if (record.getRemark() != null) {
            sql.SET("remark = #{remark,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getSalesTime() != null) {
            sql.SET("sales_time = #{salesTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperatorId() != null) {
            sql.SET("operator_id = #{operatorId,jdbcType=BIGINT}");
        }
        
        if (record.getOperatorName() != null) {
            sql.SET("operator_name = #{operatorName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighCouponAgentCodeExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}